import gtk

# FIXME below class should/could handle height/width
class VerticalImageLabelButton(gtk.Button):
    def __init__(self, image_filename, labeltext, click_callback = None):
        gtk.Button.__init__(self)
        self.vbox = gtk.VBox()

        # Image
        self.pixbuf = gtk.gdk.pixbuf_new_from_file(image_filename)
        self.image = gtk.Image()
        self.image.set_from_pixbuf(self.pixbuf)
        self.vbox.pack_start(self.image)
        self.image.show()

        # Label
        self.label = gtk.Label(labeltext)
        self.vbox.pack_start(self.label)
        self.label.show()
        
        # vbox
        self.vbox.show()

        # self
        self.add(self.vbox)

        # insensitive
        self.set_sensitive(False)

        # Callbacks, complaints.
        self.connect('clicked', click_callback)
        
        # On hover...     
        # Connect the enter signal to set the background color
        self.connect('enter', self.set_background, '#444444')
        # On leave, restore it
        self.connect('leave', self.set_background, '#808080')

    def set_background(self, widget, value):
        self.modify_base(gtk.STATE_NORMAL, gtk.gdk.color_parse(value))
        self.modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse(value))
